; $LastChangedDate: 2008-07-24 17:18:48 -0500 (Thu, 24 Jul 2008) $
; $LastChangedRevision: 2398 $
; $HeadURL: svn://osiris/scheme-bos-clug/tags/2.01/2-prm-feat-tsts.scm $
;
; Tests to verify that the primitive objects exhibit the expected 
; behavior.
#lang scheme

(require "1-prm-feat.scm"
         (planet "test.ss" ("schematics" "schemeunit.plt" 2 8))
         (planet "text-ui.ss" ("schematics" "schemeunit.plt" 2))
         (planet "graphical-ui.ss" ("schematics" "schemeunit.plt" 2 8)))

(provide 2-prm-feat-tsts)

(define 2-prm-feat-tsts
  (test-suite 
   "Tests for 2-prm-feat-tsts"
   
   ; Create it
   (test-case 
    "prim-obj-creation"
    (let ([obj (prim-obj-creation)])
      (check-not-false obj "creation")))
   
   ; Create it and return an equivelant message
   (test-case 
    "prim-obj-msg-passing"
    (let ([obj (prim-obj-msg-passing)])
      (check-not-false obj "creation")
      (check-not-false (obj 'msg) "message passing")))
   
   ; Create it, return an equivelant message, and then
   ; verify that it retained its lexical scope
   (test-case 
    "prim-obj-lex-scope"
    (let ([obj (prim-obj-lex-scope)])
      (check-not-false obj "creation")
      (check-not-false (obj 'msg) "message passing" )
      (check-eq? (cdr (obj 'msg)) 23 "lexical environment")))))