; $LastChangedDate: 2008-07-24 17:20:55 -0500 (Thu, 24 Jul 2008) $
; $LastChangedRevision: 2401 $
; $HeadURL: svn://osiris/scheme-bos-clug/tags/2.01/4-prim-obj-stx.scm $
;
; Using the person class as the basis, the following macros define
; the shape of and transformation for the generation of primitive
; objects.
#lang scheme

(provide define-object)

; the first bad identifier form syntax object, or #f
(define-for-syntax 1st-bad-id
  (lambda (ls)
    (cond
      [(null? ls) #f]
      [(not (identifier? (car ls))) (car ls)]
      [else (1st-bad-id (cdr ls))])))

; the first duplicate identifier syntax object, or #f
(define-for-syntax 1st-dup-id
  (λ (ls)          
    (define duplicate
      (λ (id ls) 
        (cond 
          [(null? ls) #f]
          [(bound-identifier=? id (car ls)) (car ls)]
          [else (duplicate id (cdr ls))])))
    (if (null? ls) #f
        (let ([duplicate-id (duplicate (car ls) (cdr ls))])
          (if duplicate-id duplicate-id
              (1st-dup-id (cdr ls)))))))

; shorthand
(define-for-syntax dtm->stx datum->syntax)
(define-for-syntax serr raise-syntax-error)

; primitive object syntax
(define-syntax define-object
  (λ (stx) 
    (syntax-case stx (variables methods)
      [(define-object name
         (variables ([v-name v-val] ...))
         (methods ([m-name m-args m-body] ...)))   
       (with-syntax 
           ([class-name 
             (dtm->stx #'define-object 'class-name)]
            [method-names 
             (dtm->stx #'define-object 'method-names)]
            [method-names-ls 
             (dtm->stx #'define-object 'method-names-ls)])
         (let ([bad-id-so 
                (1st-bad-id (syntax->list #'(v-name ... m-name ...)))])
           (if bad-id-so             
               (serr #f "variable and method names must be identifiers" bad-id-so)
               (let ([dup-id-so 
                      (1st-dup-id 
                       (syntax->list 
                        #'(class-name 
                           method-names 
                           method-names-ls 
                           v-name ... m-name ...)))])
                 (if dup-id-so
                     (serr #f "variable and method names must be uniqueI" dup-id-so)
                     #'(define name
                         (λ () 
                           (define class-name (λ () 'name))              
                           (define method-names (λ () method-names-ls))
                           (define method-names-ls '(class-name method-names m-name ...))
                           (define v-name v-val) ...
                           (define m-name (λ m-args m-body)) ...
                           (λ (msg . args) 
                             (case msg                  
                               [(class-name) (class-name)]
                               [(method-names) (method-names)]
                               [(m-name) (apply m-name args)] ...
                               [else 
                                (raise (string-append "message '" (symbol->string msg) "' not understood"))])))))))))])))